library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity licznik_h is
    Port ( clk : in std_logic;
           res, mode : in std_logic; -- mode=0 -> 24h
           outp_j : inout std_logic_vector(9 downto 0);
           outp_dz : inout std_logic_vector(2 downto 1)
			);
end licznik_h;

architecture beh of licznik_h is
signal stan: std_logic_vector(11 downto 0);
constant godzina_0: std_logic_vector(11 downto 0) := "000000000001";
constant godzina_1: std_logic_vector(11 downto 0) := "000000000010";
constant godzina_2: std_logic_vector(11 downto 0) := "000000000100";
constant godzina_3: std_logic_vector(11 downto 0) := "000000001000";
constant godzina_4: std_logic_vector(11 downto 0) := "000000010000";
constant godzina_5: std_logic_vector(11 downto 0) := "000000100000";
constant godzina_6: std_logic_vector(11 downto 0) := "000001000000";
constant godzina_7: std_logic_vector(11 downto 0) := "000010000000";
constant godzina_8: std_logic_vector(11 downto 0) := "000100000000";
constant godzina_9: std_logic_vector(11 downto 0) := "001000000000";
constant godzina_10: std_logic_vector(11 downto 0) := "010000000001";
constant godzina_11: std_logic_vector(11 downto 0) := "010000000010";
constant godzina_12: std_logic_vector(11 downto 0) := "010000000100";
constant godzina_13: std_logic_vector(11 downto 0) := "010000001000";
constant godzina_14: std_logic_vector(11 downto 0) := "010000010000";
constant godzina_15: std_logic_vector(11 downto 0) := "010000100000";
constant godzina_16: std_logic_vector(11 downto 0) := "010001000000";
constant godzina_17: std_logic_vector(11 downto 0) := "010010000000";
constant godzina_18: std_logic_vector(11 downto 0) := "010100000000";
constant godzina_19: std_logic_vector(11 downto 0) := "011000000000";
constant godzina_20: std_logic_vector(11 downto 0) := "100000000001";
constant godzina_21: std_logic_vector(11 downto 0) := "100000000010";
constant godzina_22: std_logic_vector(11 downto 0) := "100000000100";
constant godzina_23: std_logic_vector(11 downto 0) := "100000001000";

begin
	process (clk, res)
	begin
		if res = '1' and mode = '0' then
		stan <= godzina_0;
		elsif res = '1' and mode = '1' then
		stan <= godzina_12;
		elsif clk'event and clk = '1' then
			if mode = '0' then
				case stan is
					when godzina_0 => stan <= godzina_1;
					when godzina_1 => stan <= godzina_2;
					when godzina_2 => stan <= godzina_3;
					when godzina_3 => stan <= godzina_4;
					when godzina_4 => stan <= godzina_5;
					when godzina_5 => stan <= godzina_6;
					when godzina_6 => stan <= godzina_7;
					when godzina_7 => stan <= godzina_8;
					when godzina_8 => stan <= godzina_9;
					when godzina_9 => stan <= godzina_10;
					when godzina_10 => stan <= godzina_11;
					when godzina_11 => stan <= godzina_12;
					when godzina_12 => stan <= godzina_13;
					when godzina_13 => stan <= godzina_14;
					when godzina_14 => stan <= godzina_15;
					when godzina_15 => stan <= godzina_16;
					when godzina_16 => stan <= godzina_17;
					when godzina_17 => stan <= godzina_18;
					when godzina_18 => stan <= godzina_19;
					when godzina_19 => stan <= godzina_20;
					when godzina_20 => stan <= godzina_21;
					when godzina_21 => stan <= godzina_22;
					when godzina_22 => stan <= godzina_23;
					when godzina_23 => stan <= godzina_0;
					when others => stan <= godzina_0;
				 end case;

			elsif mode = '1' then
				case stan is
					when godzina_12 => stan <= godzina_1;
					when godzina_1 => stan <= godzina_2;
					when godzina_2 => stan <= godzina_3;
					when godzina_3 => stan <= godzina_4;
					when godzina_4 => stan <= godzina_5;
					when godzina_5 => stan <= godzina_6;
					when godzina_6 => stan <= godzina_7;
					when godzina_7 => stan <= godzina_8;
					when godzina_8 => stan <= godzina_9;
					when godzina_9 => stan <= godzina_10;
					when godzina_10 => stan <= godzina_11;
					when godzina_11 => stan <= godzina_12;
					when others => stan <= godzina_12;
				end case;
			 end if;
		end if;
	outp_j <= stan(9 downto 0);
   outp_dz <= stan(11 downto 10);
	end process;
end beh;
